<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: SPI.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SPI.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * SPI.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Mar 3, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_SPI_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_SPI_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;driver/spi_master.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;driver/gpio.h&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classSPI.html">   15</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSPI.html">SPI</a> {</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <a class="code" href="classSPI.html#a2ba081c29fbdecc704c6bf00b24d5205">SPI</a>();</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classSPI.html#a6babebf1ea3e8ff0330f43a3e2312ac4">~SPI</a>();</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keywordtype">void</span>    <a class="code" href="classSPI.html#a832556869c632024fe6ab92473854131">init</a>(</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keywordtype">int</span> mosiPin = <a class="code" href="classSPI.html#a311aea82b4ba1b8b57ac88ec62c94bf2">DEFAULT_MOSI_PIN</a>,</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="keywordtype">int</span> misoPin = <a class="code" href="classSPI.html#af64304a498004d8abd46931cfbb5bba6">DEFAULT_MISO_PIN</a>,</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keywordtype">int</span> clkPin  = <a class="code" href="classSPI.html#a26f31b5eb7b69e66761d387116ea0003">DEFAULT_CLK_PIN</a>,</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keywordtype">int</span> csPin   = <a class="code" href="classSPI.html#a7ed47313c92be5762bb61a6d69a58d7e">DEFAULT_CS_PIN</a>);</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">void</span>    <a class="code" href="classSPI.html#a85ec652a3a1eb453f6b9938a45b599c9">setHost</a>(spi_host_device_t host);</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">void</span>    <a class="code" href="classSPI.html#a3d0d6d9b84a7191b4a95971eee25f746">transfer</a>(uint8_t* data, <span class="keywordtype">size_t</span> dataLen);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    uint8_t <a class="code" href="classSPI.html#aff890367df7fa27734d18c772eb227df">transferByte</a>(uint8_t value);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classSPI.html#a311aea82b4ba1b8b57ac88ec62c94bf2">   31</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classSPI.html#a311aea82b4ba1b8b57ac88ec62c94bf2">DEFAULT_MOSI_PIN</a> = GPIO_NUM_13;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classSPI.html#af64304a498004d8abd46931cfbb5bba6">   36</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classSPI.html#af64304a498004d8abd46931cfbb5bba6">DEFAULT_MISO_PIN</a> = GPIO_NUM_12;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classSPI.html#a26f31b5eb7b69e66761d387116ea0003">   41</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classSPI.html#a26f31b5eb7b69e66761d387116ea0003">DEFAULT_CLK_PIN</a>  = GPIO_NUM_14;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classSPI.html#a7ed47313c92be5762bb61a6d69a58d7e">   46</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classSPI.html#a7ed47313c92be5762bb61a6d69a58d7e">DEFAULT_CS_PIN</a>   = GPIO_NUM_15;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classSPI.html#acebfbe004601caf512d1b5b84b1a0967">   51</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classSPI.html#acebfbe004601caf512d1b5b84b1a0967">PIN_NOT_SET</a>      = -1;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  spi_device_handle_t m_handle;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  spi_host_device_t   m_host;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;};</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_SPI_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classSPI_html_acebfbe004601caf512d1b5b84b1a0967"><div class="ttname"><a href="classSPI.html#acebfbe004601caf512d1b5b84b1a0967">SPI::PIN_NOT_SET</a></div><div class="ttdeci">static const int PIN_NOT_SET</div><div class="ttdoc">Value of unset pin.</div><div class="ttdef"><b>Definition:</b> SPI.h:51</div></div>
<div class="ttc" id="classSPI_html"><div class="ttname"><a href="classSPI.html">SPI</a></div><div class="ttdoc">Handle SPI protocol.</div><div class="ttdef"><b>Definition:</b> SPI.h:15</div></div>
<div class="ttc" id="classSPI_html_a3d0d6d9b84a7191b4a95971eee25f746"><div class="ttname"><a href="classSPI.html#a3d0d6d9b84a7191b4a95971eee25f746">SPI::transfer</a></div><div class="ttdeci">void transfer(uint8_t *data, size_t dataLen)</div><div class="ttdoc">Send and receive data through SPI. This is a blocking call.</div><div class="ttdef"><b>Definition:</b> SPI.cpp:111</div></div>
<div class="ttc" id="classSPI_html_a2ba081c29fbdecc704c6bf00b24d5205"><div class="ttname"><a href="classSPI.html#a2ba081c29fbdecc704c6bf00b24d5205">SPI::SPI</a></div><div class="ttdeci">SPI()</div><div class="ttdoc">Construct an instance of the class.</div><div class="ttdef"><b>Definition:</b> SPI.cpp:21</div></div>
<div class="ttc" id="classSPI_html_a6babebf1ea3e8ff0330f43a3e2312ac4"><div class="ttname"><a href="classSPI.html#a6babebf1ea3e8ff0330f43a3e2312ac4">SPI::~SPI</a></div><div class="ttdeci">virtual ~SPI()</div><div class="ttdoc">Class instance destructor.</div><div class="ttdef"><b>Definition:</b> SPI.cpp:30</div></div>
<div class="ttc" id="classSPI_html_a85ec652a3a1eb453f6b9938a45b599c9"><div class="ttname"><a href="classSPI.html#a85ec652a3a1eb453f6b9938a45b599c9">SPI::setHost</a></div><div class="ttdeci">void setHost(spi_host_device_t host)</div><div class="ttdoc">Set the SPI host to use. Call this prior to init().</div><div class="ttdef"><b>Definition:</b> SPI.cpp:100</div></div>
<div class="ttc" id="classSPI_html_a26f31b5eb7b69e66761d387116ea0003"><div class="ttname"><a href="classSPI.html#a26f31b5eb7b69e66761d387116ea0003">SPI::DEFAULT_CLK_PIN</a></div><div class="ttdeci">static const int DEFAULT_CLK_PIN</div><div class="ttdoc">The default CLK pin.</div><div class="ttdef"><b>Definition:</b> SPI.h:41</div></div>
<div class="ttc" id="classSPI_html_af64304a498004d8abd46931cfbb5bba6"><div class="ttname"><a href="classSPI.html#af64304a498004d8abd46931cfbb5bba6">SPI::DEFAULT_MISO_PIN</a></div><div class="ttdeci">static const int DEFAULT_MISO_PIN</div><div class="ttdoc">The default MISO pin.</div><div class="ttdef"><b>Definition:</b> SPI.h:36</div></div>
<div class="ttc" id="classSPI_html_a311aea82b4ba1b8b57ac88ec62c94bf2"><div class="ttname"><a href="classSPI.html#a311aea82b4ba1b8b57ac88ec62c94bf2">SPI::DEFAULT_MOSI_PIN</a></div><div class="ttdeci">static const int DEFAULT_MOSI_PIN</div><div class="ttdoc">The default MOSI pin.</div><div class="ttdef"><b>Definition:</b> SPI.h:31</div></div>
<div class="ttc" id="classSPI_html_a7ed47313c92be5762bb61a6d69a58d7e"><div class="ttname"><a href="classSPI.html#a7ed47313c92be5762bb61a6d69a58d7e">SPI::DEFAULT_CS_PIN</a></div><div class="ttdeci">static const int DEFAULT_CS_PIN</div><div class="ttdoc">The default CS pin.</div><div class="ttdef"><b>Definition:</b> SPI.h:46</div></div>
<div class="ttc" id="classSPI_html_a832556869c632024fe6ab92473854131"><div class="ttname"><a href="classSPI.html#a832556869c632024fe6ab92473854131">SPI::init</a></div><div class="ttdeci">void init(int mosiPin=DEFAULT_MOSI_PIN, int misoPin=DEFAULT_MISO_PIN, int clkPin=DEFAULT_CLK_PIN, int csPin=DEFAULT_CS_PIN)</div><div class="ttdoc">Initialize SPI.</div><div class="ttdef"><b>Definition:</b> SPI.cpp:47</div></div>
<div class="ttc" id="classSPI_html_aff890367df7fa27734d18c772eb227df"><div class="ttname"><a href="classSPI.html#aff890367df7fa27734d18c772eb227df">SPI::transferByte</a></div><div class="ttdeci">uint8_t transferByte(uint8_t value)</div><div class="ttdoc">Send and receive a single byte.</div><div class="ttdef"><b>Definition:</b> SPI.cpp:141</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
